<?php
/* Autor...:  */
/* Esquema.: SR_DevolucionCabecera.xml */
/* Generado: 2021-06-25 10:06:37 */

/* Metodos de acceso a los campos de la tabla SR_DevolucionCabecera */
abstract class BaseSR_DevolucionCabeceraBN
{
    /* Campos de la tabla */
    private $i_DevolucionCabId;    // DevolucionCabId: ( no definido )
    private $i_IdCompania;    // IdCompania: ( no definido )
    private $i_IdSucursal;    // IdSucursal: ( no definido )
    private $i_IdProyecto;    // IdProyecto: ( no definido )
    private $i_OrdenId;    // OrdenId: ( no definido )
    private $i_ParentId;    // ParentId: ( no definido )
    private $s_Tipo;    // Tipo: ( no definido )
    private $s_TransGuiaSerie;    // TransGuiaSerie: ( no definido )
    private $s_TransGuiaNumero;    // TransGuiaNumero: ( no definido )
    private $s_ObraGuiaSerie;    // ObraGuiaSerie: ( no definido )
    private $s_ObraGuiaNumero;    // ObraGuiaNumero: ( no definido )
    private $s_Observaciones;    // Observaciones: ( no definido )
    private $d_FechaInicioAlq;    // FechaInicioAlq: ( no definido )
    private $d_FechaDevolucion;    // FechaDevolucion: ( no definido )
    private $s_Estado;    // Estado: ( no definido )
    private $s_EstadoCorte;    // EstadoCorte: ( no definido )
    private $d_FechaCreacion;    // FechaCreacion: ( no definido )
    private $s_UsuarioCreacion;    // UsuarioCreacion: ( no definido )
    private $d_FechaModificacion;    // FechaModificacion: ( no definido )
    private $s_UsuarioModificacion;    // UsuarioModificacion: ( no definido )

    /* Establece el valor del campo DevolucionCabId */
    public function setDevolucionCabId( $i_DevolucionCabId )
    {
        $this->i_DevolucionCabId = $i_DevolucionCabId;
    }

    /* Obtiene el valor del campo DevolucionCabId */
    public function getDevolucionCabId()
    {
        return $this->i_DevolucionCabId;
    }

    /* Establece el valor del campo IdCompania */
    public function setIdCompania( $i_IdCompania )
    {
        $this->i_IdCompania = $i_IdCompania;
    }

    /* Obtiene el valor del campo IdCompania */
    public function getIdCompania()
    {
        return $this->i_IdCompania;
    }

    /* Establece el valor del campo IdSucursal */
    public function setIdSucursal( $i_IdSucursal )
    {
        $this->i_IdSucursal = $i_IdSucursal;
    }

    /* Obtiene el valor del campo IdSucursal */
    public function getIdSucursal()
    {
        return $this->i_IdSucursal;
    }

    /* Establece el valor del campo IdProyecto */
    public function setIdProyecto( $i_IdProyecto )
    {
        $this->i_IdProyecto = $i_IdProyecto;
    }

    /* Obtiene el valor del campo IdProyecto */
    public function getIdProyecto()
    {
        return $this->i_IdProyecto;
    }

    /* Establece el valor del campo OrdenId */
    public function setOrdenId( $i_OrdenId )
    {
        $this->i_OrdenId = $i_OrdenId;
    }

    /* Obtiene el valor del campo OrdenId */
    public function getOrdenId()
    {
        return $this->i_OrdenId;
    }

    /* Establece el valor del campo ParentId */
    public function setParentId( $i_ParentId )
    {
        $this->i_ParentId = $i_ParentId;
    }

    /* Obtiene el valor del campo ParentId */
    public function getParentId()
    {
        return $this->i_ParentId;
    }

    /* Establece el valor del campo Tipo */
    public function setTipo( $s_Tipo )
    {
        $this->s_Tipo = $s_Tipo;
    }

    /* Obtiene el valor del campo Tipo */
    public function getTipo()
    {
        return $this->s_Tipo;
    }

    /* Establece el valor del campo TransGuiaSerie */
    public function setTransGuiaSerie( $s_TransGuiaSerie )
    {
        $this->s_TransGuiaSerie = $s_TransGuiaSerie;
    }

    /* Obtiene el valor del campo TransGuiaSerie */
    public function getTransGuiaSerie()
    {
        return $this->s_TransGuiaSerie;
    }

    /* Establece el valor del campo TransGuiaNumero */
    public function setTransGuiaNumero( $s_TransGuiaNumero )
    {
        $this->s_TransGuiaNumero = $s_TransGuiaNumero;
    }

    /* Obtiene el valor del campo TransGuiaNumero */
    public function getTransGuiaNumero()
    {
        return $this->s_TransGuiaNumero;
    }

    /* Establece el valor del campo ObraGuiaSerie */
    public function setObraGuiaSerie( $s_ObraGuiaSerie )
    {
        $this->s_ObraGuiaSerie = $s_ObraGuiaSerie;
    }

    /* Obtiene el valor del campo ObraGuiaSerie */
    public function getObraGuiaSerie()
    {
        return $this->s_ObraGuiaSerie;
    }

    /* Establece el valor del campo ObraGuiaNumero */
    public function setObraGuiaNumero( $s_ObraGuiaNumero )
    {
        $this->s_ObraGuiaNumero = $s_ObraGuiaNumero;
    }

    /* Obtiene el valor del campo ObraGuiaNumero */
    public function getObraGuiaNumero()
    {
        return $this->s_ObraGuiaNumero;
    }

    /* Establece el valor del campo Observaciones */
    public function setObservaciones( $s_Observaciones )
    {
        $this->s_Observaciones = $s_Observaciones;
    }

    /* Obtiene el valor del campo Observaciones */
    public function getObservaciones()
    {
        return $this->s_Observaciones;
    }

    /* Establece el valor del campo FechaInicioAlq */
    public function setFechaInicioAlq( $d_FechaInicioAlq )
    {
        $this->d_FechaInicioAlq = $d_FechaInicioAlq;
    }

    /* Obtiene el valor del campo FechaInicioAlq */
    public function getFechaInicioAlq()
    {
        return $this->d_FechaInicioAlq;
    }

    /* Establece el valor del campo FechaDevolucion */
    public function setFechaDevolucion( $d_FechaDevolucion )
    {
        $this->d_FechaDevolucion = $d_FechaDevolucion;
    }

    /* Obtiene el valor del campo FechaDevolucion */
    public function getFechaDevolucion()
    {
        return $this->d_FechaDevolucion;
    }

    /* Establece el valor del campo Estado */
    public function setEstado( $s_Estado )
    {
        $this->s_Estado = $s_Estado;
    }

    /* Obtiene el valor del campo Estado */
    public function getEstado()
    {
        return $this->s_Estado;
    }

    /* Establece el valor del campo EstadoCorte */
    public function setEstadoCorte( $s_EstadoCorte )
    {
        $this->s_EstadoCorte = $s_EstadoCorte;
    }

    /* Obtiene el valor del campo EstadoCorte */
    public function getEstadoCorte()
    {
        return $this->s_EstadoCorte;
    }

    /* Establece el valor del campo FechaCreacion */
    public function setFechaCreacion( $d_FechaCreacion )
    {
        $this->d_FechaCreacion = $d_FechaCreacion;
    }

    /* Obtiene el valor del campo FechaCreacion */
    public function getFechaCreacion()
    {
        return $this->d_FechaCreacion;
    }

    /* Establece el valor del campo UsuarioCreacion */
    public function setUsuarioCreacion( $s_UsuarioCreacion )
    {
        $this->s_UsuarioCreacion = $s_UsuarioCreacion;
    }

    /* Obtiene el valor del campo UsuarioCreacion */
    public function getUsuarioCreacion()
    {
        return $this->s_UsuarioCreacion;
    }

    /* Establece el valor del campo FechaModificacion */
    public function setFechaModificacion( $d_FechaModificacion )
    {
        $this->d_FechaModificacion = $d_FechaModificacion;
    }

    /* Obtiene el valor del campo FechaModificacion */
    public function getFechaModificacion()
    {
        return $this->d_FechaModificacion;
    }

    /* Establece el valor del campo UsuarioModificacion */
    public function setUsuarioModificacion( $s_UsuarioModificacion )
    {
        $this->s_UsuarioModificacion = $s_UsuarioModificacion;
    }

    /* Obtiene el valor del campo UsuarioModificacion */
    public function getUsuarioModificacion()
    {
        return $this->s_UsuarioModificacion;
    }

    public function getJsonSerialize()
    {
        return 
        [
            'DevolucionCabId' => $this->getDevolucionCabId(),
            'IdCompania' => $this->getIdCompania(),
            'IdSucursal' => $this->getIdSucursal(),
            'IdProyecto' => $this->getIdProyecto(),
            'OrdenId' => $this->getOrdenId(),
            'ParentId' => $this->getParentId(),
            'Tipo' => $this->getTipo(),
            'TransGuiaSerie' => $this->getTransGuiaSerie(),
            'TransGuiaNumero' => $this->getTransGuiaNumero(),
            'ObraGuiaSerie' => $this->getObraGuiaSerie(),
            'ObraGuiaNumero' => $this->getObraGuiaNumero(),
            'Observaciones' => $this->getObservaciones(),
            'FechaInicioAlq' => $this->getFechaInicioAlq(),
            'FechaDevolucion' => $this->getFechaDevolucion(),
            'Estado' => $this->getEstado(),
            'EstadoCorte' => $this->getEstadoCorte(),
            'FechaCreacion' => $this->getFechaCreacion(),
            'UsuarioCreacion' => $this->getUsuarioCreacion(),
            'FechaModificacion' => $this->getFechaModificacion(),
            'UsuarioModificacion' => $this->getUsuarioModificacion(),
        ];
    }

    public function toArray()
    {
        return $this->processArray( get_object_vars( $this ) ); 
    }

    private function processArray( $array )
    {
        foreach( $array as $key => $value ) 
        {
            if ( is_object( $value ) )
            {
                $array[$key] = $value->toArray();
            }
            if ( is_array( $value ) ) 
            {
                $array[$key] = $this->processArray( $value );
            }
        }
        return $array;
    }

    public function __toString()
    {
        return json_encode( $this->toArray() ); 
    }

    /* Recupera un objeto SR_DevolucionCabeceraBN desde un RecordSet */
    public static function retrieveByRs( $o_SR_DevolucionCabeceraRs )
    {
        $o_SR_DevolucionCabeceraBN = new SR_DevolucionCabeceraBN();
        $o_SR_DevolucionCabeceraBN->setDevolucionCabId( ( integer ) $o_SR_DevolucionCabeceraRs[ "DevolucionCabId" ] );
        $o_SR_DevolucionCabeceraBN->setIdCompania( ( integer ) $o_SR_DevolucionCabeceraRs[ "IdCompania" ] );
        $o_SR_DevolucionCabeceraBN->setIdSucursal( ( integer ) $o_SR_DevolucionCabeceraRs[ "IdSucursal" ] );
        $o_SR_DevolucionCabeceraBN->setIdProyecto( ( integer ) $o_SR_DevolucionCabeceraRs[ "IdProyecto" ] );
        $o_SR_DevolucionCabeceraBN->setOrdenId( ( integer ) $o_SR_DevolucionCabeceraRs[ "OrdenId" ] );
        $o_SR_DevolucionCabeceraBN->setParentId( ( integer ) $o_SR_DevolucionCabeceraRs[ "ParentId" ] );
        $o_SR_DevolucionCabeceraBN->setTipo( $o_SR_DevolucionCabeceraRs[ "Tipo" ] );
        $o_SR_DevolucionCabeceraBN->setTransGuiaSerie( $o_SR_DevolucionCabeceraRs[ "TransGuiaSerie" ] );
        $o_SR_DevolucionCabeceraBN->setTransGuiaNumero( $o_SR_DevolucionCabeceraRs[ "TransGuiaNumero" ] );
        $o_SR_DevolucionCabeceraBN->setObraGuiaSerie( $o_SR_DevolucionCabeceraRs[ "ObraGuiaSerie" ] );
        $o_SR_DevolucionCabeceraBN->setObraGuiaNumero( $o_SR_DevolucionCabeceraRs[ "ObraGuiaNumero" ] );
        $o_SR_DevolucionCabeceraBN->setObservaciones( $o_SR_DevolucionCabeceraRs[ "Observaciones" ] );
        $o_SR_DevolucionCabeceraBN->setFechaInicioAlq( utilTimestamp::getTimestamp( $o_SR_DevolucionCabeceraRs[ "FechaInicioAlq" ], "Y-m-d" ) );
        $o_SR_DevolucionCabeceraBN->setFechaDevolucion( utilTimestamp::getTimestamp( $o_SR_DevolucionCabeceraRs[ "FechaDevolucion" ], "Y-m-d" ) );
        $o_SR_DevolucionCabeceraBN->setEstado( $o_SR_DevolucionCabeceraRs[ "Estado" ] );
        $o_SR_DevolucionCabeceraBN->setEstadoCorte( $o_SR_DevolucionCabeceraRs[ "EstadoCorte" ] );
        $o_SR_DevolucionCabeceraBN->setFechaCreacion( utilTimestamp::getTimestamp( $o_SR_DevolucionCabeceraRs[ "FechaCreacion" ], "Y-m-d H:i:s" ) );
        $o_SR_DevolucionCabeceraBN->setUsuarioCreacion( $o_SR_DevolucionCabeceraRs[ "UsuarioCreacion" ] );
        $o_SR_DevolucionCabeceraBN->setFechaModificacion( utilTimestamp::getTimestamp( $o_SR_DevolucionCabeceraRs[ "FechaModificacion" ], "Y-m-d H:i:s" ) );
        $o_SR_DevolucionCabeceraBN->setUsuarioModificacion( $o_SR_DevolucionCabeceraRs[ "UsuarioModificacion" ] );
        return $o_SR_DevolucionCabeceraBN;
    }
}
?>